// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v3_4")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlProgressButton")]
    pub struct ProgressButton(Object<ffi::DzlProgressButton, ffi::DzlProgressButtonClass>) @extends gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Actionable;

    match fn {
        type_ => || ffi::dzl_progress_button_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlProgressButton")]
    pub struct ProgressButton(Object<ffi::DzlProgressButton, ffi::DzlProgressButtonClass>) @extends gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_progress_button_get_type(),
    }
}

impl ProgressButton {
    pub const NONE: Option<&'static ProgressButton> = None;

    #[doc(alias = "dzl_progress_button_new")]
    pub fn new() -> ProgressButton {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_progress_button_new()).unsafe_cast() }
    }
}

impl Default for ProgressButton {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ProgressButton>> Sealed for T {}
}

pub trait ProgressButtonExt: IsA<ProgressButton> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_progress_button_get_progress")]
    #[doc(alias = "get_progress")]
    fn progress(&self) -> u32 {
        unsafe { ffi::dzl_progress_button_get_progress(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_progress_button_get_show_progress")]
    #[doc(alias = "get_show_progress")]
    fn shows_progress(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_progress_button_get_show_progress(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_progress_button_set_progress")]
    fn set_progress(&self, percentage: u32) {
        unsafe {
            ffi::dzl_progress_button_set_progress(self.as_ref().to_glib_none().0, percentage);
        }
    }

    #[doc(alias = "dzl_progress_button_set_show_progress")]
    fn set_show_progress(&self, show_progress: bool) {
        unsafe {
            ffi::dzl_progress_button_set_show_progress(
                self.as_ref().to_glib_none().0,
                show_progress.into_glib(),
            );
        }
    }

    #[doc(alias = "progress")]
    fn connect_progress_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_progress_trampoline<
            P: IsA<ProgressButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::progress\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_progress_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-progress")]
    fn connect_show_progress_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_progress_trampoline<
            P: IsA<ProgressButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-progress\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_progress_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<ProgressButton>> ProgressButtonExt for O {}

impl fmt::Display for ProgressButton {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ProgressButton")
    }
}
